Index: /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/CorrelationView.cs
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/CorrelationView.cs	(revision 9383)
+++ /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/CorrelationView.cs	(revision 9383)
@@ -0,0 +1,221 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.Data;
+using HeuristicLab.MainForm;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Analysis.Statistics {
+  [View("Correlation View")]
+  [Content(typeof(RunCollection), false)]
+  public sealed partial class CorrelationView : ItemView {
+    private enum ResultParameterType {
+      Result,
+      Parameter
+    }
+
+    public new RunCollection Content {
+      get { return (RunCollection)base.Content; }
+      set { base.Content = value; }
+    }
+
+    public override bool ReadOnly {
+      get { return true; }
+      set { /*not needed because results are always readonly */}
+    }
+
+    private Dictionary<string, ResultParameterType> resultsParameters;
+
+    public CorrelationView() {
+      InitializeComponent();
+      stringConvertibleMatrixView.Minimum = -1.0;
+      stringConvertibleMatrixView.Maximum = 1.0;
+    }
+
+    protected override void OnContentChanged() {
+      base.OnContentChanged();
+      resultComboBox.Items.Clear();
+
+      if (Content != null) {
+        resultsParameters = GetRowNames();
+        UpdateResultComboBox();
+      }
+    }
+
+    #region events
+    protected override void RegisterContentEvents() {
+      base.RegisterContentEvents();
+      Content.ItemsAdded += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
+      Content.ItemsRemoved += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved);
+      Content.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
+      Content.UpdateOfRunsInProgressChanged += Content_UpdateOfRunsInProgressChanged;
+    }
+
+    protected override void DeregisterContentEvents() {
+      base.DeregisterContentEvents();
+      Content.ItemsAdded -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
+      Content.ItemsRemoved -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved);
+      Content.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
+      Content.UpdateOfRunsInProgressChanged -= Content_UpdateOfRunsInProgressChanged;
+    }
+
+    private void Content_CollectionReset(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
+      RebuildCorrelationTable();
+    }
+
+    private void Content_ItemsRemoved(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
+      RebuildCorrelationTable();
+    }
+
+    private void Content_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
+      RebuildCorrelationTable();
+    }
+
+    void Content_UpdateOfRunsInProgressChanged(object sender, EventArgs e) {
+      if (!Content.UpdateOfRunsInProgress) {
+        RebuildCorrelationTable();
+      }
+    }
+
+    private void calculateCorrelation_Click(object sender, EventArgs e) {
+      RebuildCorrelationTable();
+    }
+    #endregion
+
+    private void UpdateResultComboBox() {
+      resultComboBox.Items.Clear();
+
+      resultComboBox.Items.AddRange(resultsParameters.Keys.ToArray());
+      if (resultComboBox.Items.Count > 0) resultComboBox.SelectedItem = resultComboBox.Items[0];
+    }
+
+    private List<string> GetResultRowNames() {
+      var results = (from run in Content
+                     where run.Visible
+                     from result in run.Results
+                     where result.Value is DoubleValue || result.Value is IntValue
+                     select result.Key).Distinct().ToList();
+
+      return results;
+    }
+
+    private List<string> GetParameterRowNames() {
+      var parameters = (from run in Content
+                        where run.Visible
+                        from parameter in run.Parameters
+                        where parameter.Value is DoubleValue || parameter.Value is IntValue
+                        select parameter.Key).Distinct().ToList();
+
+      return parameters;
+    }
+
+    private Dictionary<string, ResultParameterType> GetRowNames() {
+      Dictionary<string, ResultParameterType> ret = new Dictionary<string, ResultParameterType>();
+
+      var results = GetResultRowNames();
+      var parameters = GetParameterRowNames();
+
+      foreach (var r in results) {
+        ret.Add(r, ResultParameterType.Result);
+      }
+      foreach (var p in parameters) {
+        if (!ret.ContainsKey(p)) {
+          ret.Add(p, ResultParameterType.Parameter);
+        }
+      }
+
+      return ret;
+    }
+
+    private List<double> GetDoublesFromResults(List<IRun> runs, string key) {
+      List<double> res = new List<double>();
+
+      foreach (var r in runs) {
+        if (r.Results[key] is DoubleValue) {
+          res.Add(((DoubleValue)r.Results[key]).Value);
+        } else {
+          res.Add(((IntValue)r.Results[key]).Value);
+        }
+      }
+      return res;
+    }
+
+    private List<double> GetDoublesFromParameters(List<IRun> runs, string key) {
+      List<double> res = new List<double>();
+
+      foreach (var r in runs) {
+        if (r.Parameters[key] is DoubleValue) {
+          res.Add(((DoubleValue)r.Parameters[key]).Value);
+        } else {
+          res.Add(((IntValue)r.Parameters[key]).Value);
+        }
+      }
+      return res;
+    }
+
+    private void RebuildCorrelationTable() {
+      string resultName = (string)resultComboBox.SelectedItem;
+
+      var columnNames = new string[2];
+      columnNames[0] = "Pearson product-moment correlation coefficient";
+      columnNames[1] = "Spearman's rank correlation coefficient";
+
+      var runs = Content.Where(x => x.Results.ContainsKey(resultName) && x.Visible);
+
+      DoubleMatrix dt = new DoubleMatrix(resultsParameters.Count(), columnNames.Count());
+      dt.RowNames = resultsParameters.Keys.ToArray();
+      dt.ColumnNames = columnNames;
+
+      int j = 0;
+      foreach (var rowName in resultsParameters) {
+        var resultVals = GetDoublesFromResults(runs.Where(x => x.Results.ContainsKey(resultName)).Where(x => x.Results[resultName] is DoubleValue || x.Results[resultName] is IntValue).ToList(), resultName);
+
+        List<double> resultRowVals = new List<double>();
+        if (rowName.Value == ResultParameterType.Result) {
+          resultRowVals = GetDoublesFromResults(runs.Where(x => x.Results.ContainsKey(rowName.Key)).Where(x => x.Results[rowName.Key] is DoubleValue || x.Results[rowName.Key] is IntValue).ToList(), rowName.Key);
+        } else {
+          resultRowVals = GetDoublesFromParameters(runs.Where(x => x.Parameters.ContainsKey(rowName.Key)).Where(x => x.Parameters[rowName.Key] is DoubleValue || x.Parameters[rowName.Key] is IntValue).ToList(), rowName.Key);
+        }
+
+        if (resultVals.Contains(double.NaN)
+          || resultRowVals.Contains(double.NaN)
+          || resultVals.Contains(double.NegativeInfinity)
+          || resultVals.Contains(double.PositiveInfinity)
+          || resultRowVals.Contains(double.NegativeInfinity)
+          || resultRowVals.Contains(double.PositiveInfinity)) {
+          dt[j, 0] = double.NaN;
+          dt[j++, 1] = double.NaN;
+        } else {
+          dt[j, 0] = alglib.pearsoncorr2(resultVals.ToArray(), resultRowVals.ToArray());
+          dt[j++, 1] = alglib.spearmancorr2(resultVals.ToArray(), resultRowVals.ToArray());
+        }
+      }
+
+      dt.SortableView = true;
+      stringConvertibleMatrixView.Content = dt;
+    }
+  }
+}
Index: /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/CorrelationView.designer.cs
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/CorrelationView.designer.cs	(revision 9383)
+++ /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/CorrelationView.designer.cs	(revision 9383)
@@ -0,0 +1,118 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Analysis.Statistics {
+  partial class CorrelationView {
+    /// <summary>
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary>
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Windows Form Designer generated code
+
+    /// <summary>
+    /// Required method for Designer support - do not modify
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.stringConvertibleMatrixView = new HeuristicLab.Data.Views.EnhancedStringConvertibleMatrixView();
+      this.label1 = new System.Windows.Forms.Label();
+      this.resultComboBox = new System.Windows.Forms.ComboBox();
+      this.calculateCorrelation = new System.Windows.Forms.Button();
+      this.SuspendLayout();
+      // 
+      // stringConvertibleMatrixView
+      // 
+      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.stringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
+      this.stringConvertibleMatrixView.Content = null;
+      this.stringConvertibleMatrixView.Location = new System.Drawing.Point(3, 30);
+      this.stringConvertibleMatrixView.Name = "stringConvertibleMatrixView";
+      this.stringConvertibleMatrixView.ReadOnly = true;
+      this.stringConvertibleMatrixView.ShowRowsAndColumnsTextBox = true;
+      this.stringConvertibleMatrixView.ShowStatisticalInformation = true;
+      this.stringConvertibleMatrixView.Size = new System.Drawing.Size(492, 323);
+      this.stringConvertibleMatrixView.TabIndex = 0;
+      // 
+      // label1
+      // 
+      this.label1.AutoSize = true;
+      this.label1.Location = new System.Drawing.Point(5, 6);
+      this.label1.Name = "label1";
+      this.label1.Size = new System.Drawing.Size(40, 13);
+      this.label1.TabIndex = 6;
+      this.label1.Text = "Value:";
+      // 
+      // resultComboBox
+      // 
+      this.resultComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+            | System.Windows.Forms.AnchorStyles.Right)));
+      this.resultComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
+      this.resultComboBox.FormattingEnabled = true;
+      this.resultComboBox.Location = new System.Drawing.Point(71, 3);
+      this.resultComboBox.Name = "resultComboBox";
+      this.resultComboBox.Size = new System.Drawing.Size(424, 21);
+      this.resultComboBox.TabIndex = 5;
+      // 
+      // calculateCorrelation
+      // 
+      this.calculateCorrelation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
+      this.calculateCorrelation.Location = new System.Drawing.Point(310, 359);
+      this.calculateCorrelation.Name = "calculateCorrelation";
+      this.calculateCorrelation.Size = new System.Drawing.Size(185, 23);
+      this.calculateCorrelation.TabIndex = 9;
+      this.calculateCorrelation.Text = "Calculate correlation coefficient";
+      this.calculateCorrelation.UseVisualStyleBackColor = true;
+      this.calculateCorrelation.Click += new System.EventHandler(this.calculateCorrelation_Click);
+      // 
+      // ResultCorrelationView
+      // 
+      this.Controls.Add(this.calculateCorrelation);
+      this.Controls.Add(this.label1);
+      this.Controls.Add(this.resultComboBox);
+      this.Controls.Add(this.stringConvertibleMatrixView);
+      this.Name = "CorrelationView";
+      this.Size = new System.Drawing.Size(498, 385);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+    #endregion
+
+    private HeuristicLab.Data.Views.EnhancedStringConvertibleMatrixView stringConvertibleMatrixView;
+    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.ComboBox resultComboBox;
+    private System.Windows.Forms.Button calculateCorrelation;
+  }
+}
Index: /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj	(revision 9382)
+++ /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj	(revision 9383)
@@ -135,9 +135,9 @@
     </Compile>
     <Compile Include="KruskalWallis.cs" />
-    <Compile Include="ResultCorrelationView.cs">
+    <Compile Include="CorrelationView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="ResultCorrelationView.designer.cs">
-      <DependentUpon>ResultCorrelationView.cs</DependentUpon>
+    <Compile Include="CorrelationView.designer.cs">
+      <DependentUpon>CorrelationView.cs</DependentUpon>
     </Compile>
     <Compile Include="ChartAnalysisView.cs">
Index: anches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/ResultCorrelationView.cs
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/ResultCorrelationView.cs	(revision 9382)
+++ 	(revision )
@@ -1,221 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Windows.Forms;
-using HeuristicLab.Core.Views;
-using HeuristicLab.Data;
-using HeuristicLab.MainForm;
-using HeuristicLab.Optimization;
-
-namespace HeuristicLab.Analysis.Statistics {
-  [View("Result Correlation View")]
-  [Content(typeof(RunCollection), false)]
-  public sealed partial class ResultCorrelationView : ItemView {
-    public ResultCorrelationView() {
-      InitializeComponent();
-      stringConvertibleMatrixView.Minimum = -1.0;
-      stringConvertibleMatrixView.Maximum = 1.0;
-    }
-
-    public new RunCollection Content {
-      get { return (RunCollection)base.Content; }
-      set { base.Content = value; }
-    }
-
-    public override bool ReadOnly {
-      get { return true; }
-      set { /*not needed because results are always readonly */}
-    }
-
-    private Dictionary<string, ResultParameterType> resultsParameters;
-
-    protected override void OnContentChanged() {
-      base.OnContentChanged();
-      resultComboBox.Items.Clear();
-
-      if (Content != null) {
-        resultsParameters = GetRowNames();
-        UpdateResultComboBox();
-      }
-    }
-
-    #region events
-    protected override void RegisterContentEvents() {
-      base.RegisterContentEvents();
-      Content.ItemsAdded += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
-      Content.ItemsRemoved += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved);
-      Content.CollectionReset += new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
-      Content.UpdateOfRunsInProgressChanged += Content_UpdateOfRunsInProgressChanged;
-    }
-
-    protected override void DeregisterContentEvents() {
-      base.DeregisterContentEvents();
-      Content.ItemsAdded -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsAdded);
-      Content.ItemsRemoved -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_ItemsRemoved);
-      Content.CollectionReset -= new HeuristicLab.Collections.CollectionItemsChangedEventHandler<IRun>(Content_CollectionReset);
-      Content.UpdateOfRunsInProgressChanged -= Content_UpdateOfRunsInProgressChanged;
-    }
-
-    private void Content_CollectionReset(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
-      RebuildCorrelationTable();
-    }
-
-    private void Content_ItemsRemoved(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
-      RebuildCorrelationTable();
-    }
-
-    private void Content_ItemsAdded(object sender, HeuristicLab.Collections.CollectionItemsChangedEventArgs<IRun> e) {
-      RebuildCorrelationTable();
-    }
-
-    void Content_UpdateOfRunsInProgressChanged(object sender, EventArgs e) {
-      if (!Content.UpdateOfRunsInProgress) {
-        RebuildCorrelationTable();
-      }
-    }
-    #endregion
-
-    private void UpdateResultComboBox() {
-      resultComboBox.Items.Clear();
-
-      resultComboBox.Items.AddRange(resultsParameters.Keys.ToArray());
-      if (resultComboBox.Items.Count > 0) resultComboBox.SelectedItem = resultComboBox.Items[0];
-    }
-
-    private List<string> GetResultRowNames() {
-      var results = (from run in Content
-                     where run.Visible
-                     from result in run.Results
-                     where result.Value is DoubleValue || result.Value is IntValue
-                     select result.Key).Distinct().ToList();
-
-      return results;
-    }
-
-    private List<string> GetParameterRowNames() {
-      var parameters = (from run in Content
-                        where run.Visible
-                        from parameter in run.Parameters
-                        where parameter.Value is DoubleValue || parameter.Value is IntValue
-                        select parameter.Key).Distinct().ToList();
-
-      return parameters;
-    }
-
-    private Dictionary<string, ResultParameterType> GetRowNames() {
-      Dictionary<string, ResultParameterType> ret = new Dictionary<string, ResultParameterType>();
-
-      var results = GetResultRowNames();
-      var parameters = GetParameterRowNames();
-
-      foreach (var r in results) {
-        ret.Add(r, ResultParameterType.Result);
-      }
-      foreach (var p in parameters) {
-        if (!ret.ContainsKey(p)) {
-          ret.Add(p, ResultParameterType.Parameter);
-        }
-      }
-
-      return ret;
-    }
-
-    private List<double> GetDoublesFromResults(List<IRun> runs, string key) {
-      List<double> res = new List<double>();
-
-      foreach (var r in runs) {
-        if (r.Results[key] is DoubleValue) {
-          res.Add(((DoubleValue)r.Results[key]).Value);
-        } else {
-          res.Add(((IntValue)r.Results[key]).Value);
-        }
-      }
-      return res;
-    }
-
-    private List<double> GetDoublesFromParameters(List<IRun> runs, string key) {
-      List<double> res = new List<double>();
-
-      foreach (var r in runs) {
-        if (r.Parameters[key] is DoubleValue) {
-          res.Add(((DoubleValue)r.Parameters[key]).Value);
-        } else {
-          res.Add(((IntValue)r.Parameters[key]).Value);
-        }
-      }
-      return res;
-    }
-
-    private void RebuildCorrelationTable() {
-      string resultName = (string)resultComboBox.SelectedItem;
-
-      var columnNames = new string[2];
-      columnNames[0] = "Pearson product-moment correlation coefficient";
-      columnNames[1] = "Spearman's rank correlation coefficient";
-
-
-      var runs = Content.Where(x => x.Results.ContainsKey(resultName) && x.Visible);
-
-      DoubleMatrix dt = new DoubleMatrix(resultsParameters.Count(), columnNames.Count());
-      dt.RowNames = resultsParameters.Keys.ToArray();
-      dt.ColumnNames = columnNames;
-
-      int j = 0;
-      foreach (var rowName in resultsParameters) {
-        var resultVals = GetDoublesFromResults(runs.Where(x => x.Results.ContainsKey(resultName)).Where(x => x.Results[resultName] is DoubleValue || x.Results[resultName] is IntValue).ToList(), resultName);
-
-        List<double> resultRowVals = new List<double>();
-        if (rowName.Value == ResultParameterType.Result) {
-          resultRowVals = GetDoublesFromResults(runs.Where(x => x.Results.ContainsKey(rowName.Key)).Where(x => x.Results[rowName.Key] is DoubleValue || x.Results[rowName.Key] is IntValue).ToList(), rowName.Key);
-        } else {
-          resultRowVals = GetDoublesFromParameters(runs.Where(x => x.Parameters.ContainsKey(rowName.Key)).Where(x => x.Parameters[rowName.Key] is DoubleValue || x.Parameters[rowName.Key] is IntValue).ToList(), rowName.Key);
-        }
-
-        if (resultVals.Contains(double.NaN)
-          || resultRowVals.Contains(double.NaN)
-          || resultVals.Contains(double.NegativeInfinity)
-          || resultVals.Contains(double.PositiveInfinity)
-          || resultRowVals.Contains(double.NegativeInfinity)
-          || resultRowVals.Contains(double.PositiveInfinity)) {
-          dt[j, 0] = double.NaN;
-          dt[j++, 1] = double.NaN;
-        } else {
-          dt[j, 0] = alglib.pearsoncorr2(resultVals.ToArray(), resultRowVals.ToArray());
-          dt[j++, 1] = alglib.spearmancorr2(resultVals.ToArray(), resultRowVals.ToArray());
-        }
-      }
-
-      stringConvertibleMatrixView.Content = dt;
-    }
-
-    private void calculateCorrelation_Click(object sender, EventArgs e) {
-      RebuildCorrelationTable();
-    }
-
-    private enum ResultParameterType {
-      Result,
-      Parameter
-    }
-  }
-}
Index: anches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/ResultCorrelationView.designer.cs
===================================================================
--- /branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/ResultCorrelationView.designer.cs	(revision 9382)
+++ 	(revision )
@@ -1,118 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-namespace HeuristicLab.Analysis.Statistics {
-  partial class ResultCorrelationView {
-    /// <summary>
-    /// Required designer variable.
-    /// </summary>
-    private System.ComponentModel.IContainer components = null;
-
-    /// <summary>
-    /// Clean up any resources being used.
-    /// </summary>
-    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
-    protected override void Dispose(bool disposing) {
-      if (disposing && (components != null)) {
-        components.Dispose();
-      }
-      base.Dispose(disposing);
-    }
-
-    #region Windows Form Designer generated code
-
-    /// <summary>
-    /// Required method for Designer support - do not modify
-    /// the contents of this method with the code editor.
-    /// </summary>
-    private void InitializeComponent() {
-      this.stringConvertibleMatrixView = new HeuristicLab.Data.Views.EnhancedStringConvertibleMatrixView();
-      this.label1 = new System.Windows.Forms.Label();
-      this.resultComboBox = new System.Windows.Forms.ComboBox();
-      this.calculateCorrelation = new System.Windows.Forms.Button();
-      this.SuspendLayout();
-      // 
-      // stringConvertibleMatrixView
-      // 
-      this.stringConvertibleMatrixView.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
-            | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.stringConvertibleMatrixView.Caption = "StringConvertibleMatrix View";
-      this.stringConvertibleMatrixView.Content = null;
-      this.stringConvertibleMatrixView.Location = new System.Drawing.Point(3, 30);
-      this.stringConvertibleMatrixView.Name = "stringConvertibleMatrixView";
-      this.stringConvertibleMatrixView.ReadOnly = true;
-      this.stringConvertibleMatrixView.ShowRowsAndColumnsTextBox = true;
-      this.stringConvertibleMatrixView.ShowStatisticalInformation = true;
-      this.stringConvertibleMatrixView.Size = new System.Drawing.Size(492, 323);
-      this.stringConvertibleMatrixView.TabIndex = 0;
-      // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(5, 6);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(40, 13);
-      this.label1.TabIndex = 6;
-      this.label1.Text = "Result:";
-      // 
-      // resultComboBox
-      // 
-      this.resultComboBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.resultComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
-      this.resultComboBox.FormattingEnabled = true;
-      this.resultComboBox.Location = new System.Drawing.Point(71, 3);
-      this.resultComboBox.Name = "resultComboBox";
-      this.resultComboBox.Size = new System.Drawing.Size(424, 21);
-      this.resultComboBox.TabIndex = 5;
-      // 
-      // calculateCorrelation
-      // 
-      this.calculateCorrelation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right)));
-      this.calculateCorrelation.Location = new System.Drawing.Point(310, 359);
-      this.calculateCorrelation.Name = "calculateCorrelation";
-      this.calculateCorrelation.Size = new System.Drawing.Size(185, 23);
-      this.calculateCorrelation.TabIndex = 9;
-      this.calculateCorrelation.Text = "Calculate correlation coefficient";
-      this.calculateCorrelation.UseVisualStyleBackColor = true;
-      this.calculateCorrelation.Click += new System.EventHandler(this.calculateCorrelation_Click);
-      // 
-      // ResultCorrelationView
-      // 
-      this.Controls.Add(this.calculateCorrelation);
-      this.Controls.Add(this.label1);
-      this.Controls.Add(this.resultComboBox);
-      this.Controls.Add(this.stringConvertibleMatrixView);
-      this.Name = "ResultCorrelationView";
-      this.Size = new System.Drawing.Size(498, 385);
-      this.ResumeLayout(false);
-      this.PerformLayout();
-
-    }
-    #endregion
-
-    private HeuristicLab.Data.Views.EnhancedStringConvertibleMatrixView stringConvertibleMatrixView;
-    private System.Windows.Forms.Label label1;
-    private System.Windows.Forms.ComboBox resultComboBox;
-    private System.Windows.Forms.Button calculateCorrelation;
-  }
-}